<!--
 Copyright © VNG Realisatie 2023
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <p>
        <a href="/contracts" class="button--link"
            >{{ svg "icon-chevron-left" "icon--inline" }} {{ i18n "Back" }}</a
        >
    </p>

    <div class="add-contract-page">
        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-boost="true"
            hx-swap="outerHTML show:window:top"
            action="/contracts/add"
            method="post"
            autocomplete="off"
            class="add-contract-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />

            <!-- This list is reused for multiple grant types -->
            <datalist id="outway-public-key-thumbprints">
                {{ range $thumbprint, $outwayNames := $.OutwayPublicKeyThumbprints }}
                    <option value="{{ $thumbprint }}">
                        {{ join $outwayNames }} -
                        {{ $thumbprint }}
                    </option>
                {{ end }}
            </datalist>

            <datalist id="peerIDs">
                {{ range $peerID, $peer := $.PeerIDs }}
                    <option value="{{ $peerID }}" label="{{ $peer }}"></option>
                {{ end }}
            </datalist>

            <datalist id="serviceNames">
                {{ range $serviceName, $serviceURL := $.ServiceNames }}
                    <option
                        value="{{ $serviceName }}"
                        label="{{ $serviceName }}"
                    ></option>
                {{ end }}
            </datalist>

            <fieldset class="add-contract-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Add contract" }}
                </button>
            </fieldset>

            <fieldset>
                <label for="hashAlgorithm">
                    {{ i18n "Hash algorithm" }}
                </label>
                <div class="select">
                    <select name="hashAlgorithm" id="hashAlgorithm">
                        {{ range $label := $.HashAlgorithms }}
                            <option value="{{ $label }}">{{ $label }}</option>
                        {{ end }}
                    </select>
                </div>

                <label for="groupID">
                    {{ i18n "Group" }}
                </label>
                <div class="select">
                    <select name="groupID" id="groupID">
                        {{ range $group := $.Groups }}
                            <option value="{{ $group }}">{{ $group }}</option>
                        {{ end }}
                    </select>
                </div>

                <div class="add-contract-page__date-field-wrapper">
                    <label class="add-contract-page__date-field">
                        {{ i18n "Valid from" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validFrom"
                            value="{{ .Form.ValidFrom }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>

                    <label class="add-contract-page__date-field">
                        {{ i18n "Valid until" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validUntil"
                            value="{{ .Form.ValidUntil }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>
                </div>
            </fieldset>

            <fieldset>
                <legend>ServicePublicationGrants</legend>

                <button
                    class="button--link"
                    name="action"
                    value="{{ .FormActionAddServicePublicationGrant }}"
                >
                    {{ svg "icon-plus"
                        "icon--inline"
                    }}

                    {{ i18n "Add" }}
                </button>

                {{ range $i, $grant := .Form.ServicePublicationGrants }}
                    <h3>ServicePublicationGrant {{ inc $i }}</h3>

                    <label>
                        <span>{{ i18n "Directory Peer ID" }}</span>
                        <small
                            >Peer ID van de Directory waar je de service wil
                            publiceren.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="servicePublicationGrants.{{ $i }}.directoryPeerID"
                                value="{{ $grant.DirectoryPeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Service Peer ID" }}</span>
                        <small
                            >Jouw eigen ID als Peer die de service zal
                            aanbieden.</small
                        >
                        <input
                            class="input--medium"
                            type="text"
                            name="servicePublicationGrants.{{ $i }}.servicePeerID"
                            value="{{ $grant.ServicePeerID }}"
                            readonly
                        />
                    </label>

                    <label>
                        <span>{{ i18n "Service Name" }}</span>
                        <small
                            >Naam van de Service die je wilt publiceren.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="serviceNames"
                                name="servicePublicationGrants.{{ $i }}.serviceName"
                                value="{{ $grant.ServiceName }}"
                            />
                        </div>
                    </label>
                {{ end }}
            </fieldset>

            <fieldset>
                <legend>ServiceConnectionGrants</legend>

                <button
                    class="button--link"
                    name="action"
                    value="{{ .FormActionAddServiceConnectionGrant }}"
                >
                    {{ svg "icon-plus"
                        "icon--inline"
                    }}

                    {{ i18n "Add" }}
                </button>

                {{ range $i, $grant := .Form.ServiceConnectionGrants }}
                    <h3>ServiceConnectionGrant {{ inc $i }}</h3>

                    <label>
                        <span>{{ i18n "Service Peer ID" }}</span>
                        <small>Peer ID van de eigenaar van de Service.</small>
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="serviceConnectionGrants.{{ $i }}.servicePeerID"
                                value="{{ $grant.ServicePeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Service Name" }}</span>
                        <small
                            >Naam van de service waarmee je wil
                            verbinden.</small
                        >
                        <input
                            class="input--medium"
                            type="text"
                            name="serviceConnectionGrants.{{ $i }}.serviceName"
                            value="{{ $grant.ServiceName }}"
                            pattern="^\S+$"
                            oninvalid="this.setCustomValidity('{{ i18n "Spaces are not allowed in the servicename" }}')"
                            oninput="this.setCustomValidity('')"
                        />
                    </label>

                    <label>
                        <span>{{ i18n "Service Delegator Peer ID" }}</span>
                        <small
                            >{{ i18n "Peer ID of the organization that has delegated the Service." }}</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="serviceConnectionGrants.{{ $i }}.servicePublicationDelegatorPeerID"
                                value="{{ $grant.ServicePublicationDelegatorPeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Outway Peer ID" }}</span>
                        <small
                            >Peer ID die in het contract staat van de Outway die
                            de service mag bevragen.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="serviceConnectionGrants.{{ $i }}.outwayPeerID"
                                value="{{ $grant.OutwayPeerID }}"
                            />
                        </div>
                    </label>

                    <label for="outwayPublicKeyThumbprint">
                        {{ i18n "Outway Public Key Thumbprint" }}
                    </label>
                    <div class="datalist datalist--large">
                        <input
                            list="outway-public-key-thumbprints"
                            name="serviceConnectionGrants.{{ $i }}.outwayPublicKeyThumbprint"
                            value="{{ $grant.OutwayPublicKeyThumbprint }}"
                        />
                    </div>
                {{ end }}
            </fieldset>

            <fieldset>
                <legend>DelegatedServicePublicationGrants</legend>

                <button
                    class="button--link"
                    name="action"
                    value="{{ .FormActionAddDelegatedServicePublicationGrant }}"
                >
                    {{ svg
                        "icon-plus" "icon--inline"
                    }}

                    {{ i18n "Add" }}
                </button>

                {{ range $i, $grant := .Form.DelegatedServicePublicationGrants }}
                    <h3>DelegatedServicePublicationGrant {{ inc $i }}</h3>

                    <label>
                        <span>{{ i18n "Directory Peer ID" }}</span>
                        <small
                            >Peer ID van de Directory waar je de service wil
                            publiceren.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServicePublicationGrants.{{ $i }}.directoryPeerID"
                                value="{{ $grant.DirectoryPeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Delegator Peer ID" }}</span>
                        <small>Peer ID van de Delegator</small>
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServicePublicationGrants.{{ $i }}.delegatorPeerID"
                                value="{{ $grant.DelegatorPeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Service Peer ID" }}</span>
                        <small
                            >Jouw eigen ID als Peer die de service zal
                            aanbieden.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServicePublicationGrants.{{ $i }}.servicePeerID"
                                value="{{ $grant.ServicePeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Service Name" }}</span>
                        <small
                            >Naam van de Service die je wilt publiceren.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="serviceNames"
                                name="delegatedServicePublicationGrants.{{ $i }}.serviceName"
                                value="{{ $grant.ServiceName }}"
                            />
                        </div>
                    </label>
                {{ end }}
            </fieldset>

            <fieldset>
                <legend>DelegatedServiceConnectionGrants</legend>

                <button
                    class="button--link"
                    name="action"
                    value="{{ .FormActionAddDelegatedServiceConnectionGrant }}"
                >
                    {{ svg "icon-plus"
                        "icon--inline"
                    }}

                    {{ i18n "Add" }}
                </button>

                {{ range $i, $grant := .Form.DelegatedServiceConnectionGrants }}
                    <h3>DelegatedServiceConnectionGrant {{ inc $i }}</h3>

                    <label>
                        <span>{{ i18n "Delegator Peer ID" }}</span>
                        <small>Peer ID van de Delegator.</small>
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServiceConnectionGrants.{{ $i }}.delegatorPeerID"
                                value="{{ $grant.DelegatorPeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Delegatee Outway Peer ID" }}</span>
                        <small
                            >Peer ID die in het contract staat van de Outway die
                            de service mag bevragen.</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServiceConnectionGrants.{{ $i }}.outwayPeerID"
                                value="{{ $grant.OutwayPeerID }}"
                            />
                        </div>
                    </label>

                    <label for="outwayPublicKeyThumbprint">
                        {{ i18n "Delegatee Outway Public Key Thumbprint" }}
                    </label>
                    <div class="datalist datalist--large">
                        <input
                            list="outway-public-key-thumbprints"
                            name="delegatedServiceConnectionGrants.{{ $i }}.outwayPublickeyThumbprint"
                            value="{{ $grant.OutwayPublicKeyThumbprint }}"
                        />
                    </div>

                    <label>
                        <span>{{ i18n "Service Peer ID" }}</span>
                        <small>Peer ID van de eigenaar van de Service.</small>
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServiceConnectionGrants.{{ $i }}.servicePeerID"
                                value="{{ $grant.ServicePeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Service Delegator Peer ID" }}</span>
                        <small
                            >{{ i18n "Peer ID of the organization that has delegated the Service." }}</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="delegatedServiceConnectionGrants.{{ $i }}.servicePublicationDelegatorPeerID"
                                value="{{ $grant.ServicePublicationDelegatorPeerID }}"
                            />
                        </div>
                    </label>

                    <label>
                        <span>{{ i18n "Service Name" }}</span>
                        <small
                            >Naam van de service waarmee je wil
                            verbinden.</small
                        >
                        <input
                            class="input--medium"
                            type="text"
                            name="delegatedServiceConnectionGrants.{{ $i }}.serviceName"
                            value="{{ $grant.ServiceName }}"
                            pattern="^\S+$"
                            oninvalid="this.setCustomValidity('{{ i18n "Spaces are not allowed in the servicename" }}')"
                            oninput="this.setCustomValidity('')"
                        />
                    </label>
                {{ end }}
            </fieldset>
        </form>
    </div>
{{ end }}
